package com.link.core.basic.thread;

import com.link.base.enterprise.model.CoreEnterprise;
import com.link.base.user.model.CoreUser;
import com.link.core.basic.interceptor.SecurityInterceptor;
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.ForkJoinTask;
import java.util.concurrent.RecursiveTask;

public class LinkForkJoinPool extends ForkJoinPool {
   public <T> T invoke(final ForkJoinTask<T> task) {
      final String token = (String)SecurityInterceptor.token.get();
      final CoreUser user = (CoreUser)SecurityInterceptor.tempUser.get();
      final CoreEnterprise enterprise = (CoreEnterprise)SecurityInterceptor.tempEnterpirse.get();
      final String internalToken = (String)SecurityInterceptor.internal_token.get();
      RecursiveTask<T> action = new RecursiveTask<T>() {
         protected T compute() {
            Object var1;
            try {
               SecurityInterceptor.tempUser.set(user);
               SecurityInterceptor.tempEnterpirse.set(enterprise);
               SecurityInterceptor.token.set(token);
               SecurityInterceptor.internal_token.set(internalToken);
               var1 = task.invoke();
            } finally {
               SecurityInterceptor.tempUser.remove();
               SecurityInterceptor.tempEnterpirse.remove();
               SecurityInterceptor.token.remove();
               SecurityInterceptor.internal_token.remove();
            }

            return var1;
         }
      };
      return super.invoke(action);
   }

   public LinkForkJoinPool(int parallelism, ForkJoinPool.ForkJoinWorkerThreadFactory factory, Thread.UncaughtExceptionHandler handler, boolean asyncMode) {
      super(parallelism, factory, handler, asyncMode);
   }
}
